{******************************************************************************}
{ ˺ ȸ API Delphi SDK Example
{
{ - Ʈ  : 2022-07-25
{ -   ó : 1600-9854
{ -   ̸ : code@linkhubcorp.com
{ - SDK Ʃ丮 : https://developers.popbill.com/guide/accountcheck/delphi/getting-started/tutorial
{
{ <׽Ʈ  غ>
{ (1) 31, 34 ο  ũ̵(LinkID) Ű(SecretKey)
{    ũ Խ Ϸ ߱޹  
{
{******************************************************************************}

unit Example;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Popbill, PopbillAccountCheck;

const
        {**********************************************************************}
        { - (ũ̵, Ű) Ʈ ȸ ĺϴ        }
        {    ǹǷ  ʵ Ͻñ ٶϴ              }
        { -  ȯĿ   ʽϴ.                  }
        {**********************************************************************}

         //ũ̵.
        LinkID = 'TESTER';

        // Ʈ ſ Ű.  .
        SecretKey = 'SwWxqU+0TErBXy/9TVjIPEnI0VTUMMSQZtJf3Ed8q3I=';

type
  TfrmExample = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    btnGetBalance: TButton;
    btnGetChargeURL: TButton;
    GroupBox9: TGroupBox;
    btnGetPartnerPoint: TButton;
    btnGetPartnerURL_CHRG: TButton;
    GroupBox4: TGroupBox;
    btnRegistContact: TButton;
    btnListContact: TButton;
    btnUpdateContact: TButton;
    GroupBox3: TGroupBox;
    GroupBox2: TGroupBox;
    btnGetChargeInfo_ACC: TButton;
    btnGetChargeInfo_DEP: TButton;
    GroupBox1: TGroupBox;
    btnCheckID: TButton;
    btnGetUnitCost_ACC: TButton;
    btnGetUnitCost_DEP: TButton;
    txtCorpNum: TEdit;
    txtUserID: TEdit;
    btnJoinMember: TButton;
    btnCheckIsMember: TButton;
    btnGetAccessURL: TButton;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    btnGetCorpInfo: TButton;
    btnUpdateCorpInfo: TButton;
    btnGetPaymentURL: TButton;
    btnGetUseHistoryURL: TButton;
    btnGetContactInfo: TButton;
    GroupBox10: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    txtBankCode: TEdit;
    txtAccountNumber: TEdit;
    btnCheckAccountInfo: TButton;
    GroupBox11: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    txtBankCodeD: TEdit;
    txtAccountNumberD: TEdit;
    btnCheckDepositorInfo: TButton;
    Label7: TLabel;
    txtIdentityNumD: TEdit;
    Label8: TLabel;
    cbIdentityNumType: TComboBox;
    txtURL: TEdit;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCheckAccountInfoClick(Sender: TObject);
    procedure btnCheckDepositorInfoClick(Sender: TObject);
    procedure btnCheckIsMemberClick(Sender: TObject);
    procedure btnJoinMemberClick(Sender: TObject);
    procedure btnCheckIDClick(Sender: TObject);
    procedure btnGetBalanceClick(Sender: TObject);
    procedure btnGetUnitCost_ACCClick(Sender: TObject);
    procedure btnGetUnitCost_DEPClick(Sender: TObject);
    procedure btnGetAccessURLClick(Sender: TObject);
    procedure btnGetChargeURLClick(Sender: TObject);
    procedure btnGetPartnerPointClick(Sender: TObject);
    procedure btnRegistContactClick(Sender: TObject);
    procedure btnListContactClick(Sender: TObject);
    procedure btnUpdateContactClick(Sender: TObject);
    procedure btnGetCorpInfoClick(Sender: TObject);
    procedure btnUpdateCorpInfoClick(Sender: TObject);
    procedure btnGetChargeInfo_ACCClick(Sender: TObject);
    procedure btnGetChargeInfo_DEPClick(Sender: TObject);
    procedure btnGetPartnerURL_CHRGClick(Sender: TObject);
    procedure btnGetPaymentURLClick(Sender: TObject);
    procedure btnGetUseHistoryURLClick(Sender: TObject);
    procedure btnGetContactInfoClick(Sender: TObject);
    procedure cbIdentityNumTypeChange(Sender: TObject);
  private
    IdentityNumType : String;
  public
    { Public declarations }
  end;

var
  frmExample: TfrmExample;
  accountCheckService : TAccountCheckService;
implementation

{$R *.DFM}

procedure TfrmExample.FormCreate(Sender: TObject);
begin
        IdentityNumType := 'P';

        //ȸ  ʱȭ.
        accountCheckService := TAccountCheckService.Create(LinkID,SecretKey);

        // ȯ , true-߿, false-
        accountCheckService.IsTest := true;

        // Exception ó , true-, false-̻, ⺻(true)
        accountCheckService.IsThrowException := true;

        // ū IPѱ 뿩, true-, false-̻, ⺻(true)
        accountCheckService.IPRestrictOnOff := true;

        //ýý ð 뿩, true-, false-̻, ⺻(true)
        accountCheckService.UseLocalTimeYN := false;
end;

function BoolToStr(b:Boolean):String;
begin
    if b = true then BoolToStr:='True';
    if b = false then BoolToStr:='False';
end;


procedure TfrmExample.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        accountCheckService.Free;
        Action := caFree;
end;

procedure TfrmExample.btnCheckAccountInfoClick(Sender: TObject);
var
        accountInfo : TAccountCheckInfo;
        tmp : string;
begin
        {**********************************************************************}
        { 1 ּ ȸմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/check#CheckAccountInfo
        {**********************************************************************}

        try
                accountInfo := accountCheckService.CheckAccountInfo(txtCorpNum.text, txtBankCode.text, txtAccountNumber.text);
        except
                on le : EPopbillException do begin
                        ShowMessage(IntToStr(le.code) + ' | ' +  le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage(IntToStr(accountCheckService.LastErrCode) + ' | ' +  accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'bankCode (ڵ) : '+ accountInfo.bankCode + #13;
                tmp := tmp + 'accountNumber (¹ȣ) : '+ accountInfo.accountNumber + #13;
                tmp := tmp + 'accountName ( ) : '+ accountInfo.accountName + #13;
                tmp := tmp + 'checkDate (ȮϽ) : '+ FloatToStr(accountInfo.checkDate) + #13;
                tmp := tmp + 'result (ڵ) : '+ accountInfo.result + #13;
                tmp := tmp + 'resultMessage (޽) : '+ accountInfo.resultMessage + #13#13;

                accountInfo.Free;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnCheckDepositorInfoClick(Sender: TObject);
var
        dePositorInfo : TDepositorCheckInfo;
        tmp : string;
begin
        {**********************************************************************}
        { 1 ֽǸ ȸմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/check#CheckDepositorInfo
        {**********************************************************************}

        try
                dePositorInfo := accountCheckService.CheckDepositorInfo(txtCorpNum.text, txtBankCodeD.text, txtAccountNumberD.text, IdentityNumType, txtIdentityNumD.text);
        except
                on le : EPopbillException do begin
                        ShowMessage(IntToStr(le.code) + ' | ' +  le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage(IntToStr(accountCheckService.LastErrCode) + ' | ' +  accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'bankCode (ڵ) : '+ dePositorInfo.bankCode + #13;
                tmp := tmp + 'accountNumber (¹ȣ) : '+ dePositorInfo.accountNumber + #13;
                tmp := tmp + 'accountName ( ) : '+ dePositorInfo.accountName + #13;
                tmp := tmp + 'checkDate (ȮϽ) : '+ FloatToStr(dePositorInfo.checkDate) + #13;
                tmp := tmp + 'identityNumType (Ϲȣ ) : '+ dePositorInfo.identityNumType + #13;
                tmp := tmp + 'identityNum (Ϲȣ) : '+ dePositorInfo.identityNum + #13;
                tmp := tmp + 'result (ڵ) : '+ dePositorInfo.result + #13;
                tmp := tmp + 'resultMessage (޽) : '+ dePositorInfo.resultMessage + #13#13;

                dePositorInfo.Free;
                ShowMessage(tmp);
        end;
end;


procedure TfrmExample.btnJoinMemberClick(Sender: TObject);
var
        response : TResponse;
        joinInfo : TJoinForm;
begin
        {**********************************************************************}
        { ڸ ȸ óմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#JoinMember
        {**********************************************************************}

        // ũ̵
        joinInfo.LinkID := LinkID;

        // ڹȣ '-' , 10ڸ
        joinInfo.CorpNum := '1234567890';

        // ǥڼ, ִ 100
        joinInfo.CEOName := 'ǥڼ';

        // ȣ, ִ 200
        joinInfo.CorpName := 'ũ';

        // ּ, ִ 300
        joinInfo.Addr := 'ּ';

        // , ִ 100
        joinInfo.BizType := '';

        // , ִ 100
        joinInfo.BizClass := '';

        // ̵, 6̻ 50 ̸
        joinInfo.ID     := 'userid';

        // йȣ (8 ̻ 20 ̸) ,  ,Ư 
        joinInfo.Password := 'asdf123!@';

        // ڸ, ִ 100
        joinInfo.ContactName := 'ڸ';

        //  ó, ִ 20
        joinInfo.ContactTEL :='070-4304-2991';

        //  , ִ 100
        joinInfo.ContactEmail := 'code@linkhub.co.kr';

        try
                response := accountCheckService.JoinMember(joinInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end   
end;

procedure TfrmExample.btnCheckIsMemberClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { ڹȣ ȸϿ ȸ Կθ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#CheckIsMember
        {**********************************************************************}

        try
                response := accountCheckService.CheckIsMember(txtCorpNum.text, LinkID);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end   
end;

procedure TfrmExample.btnCheckIDClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { ϰ ϴ ̵ ߺθ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#CheckID
        {**********************************************************************}
        
        try
                response := accountCheckService.CheckID(txtUserID.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end             
end;

procedure TfrmExample.btnGetBalanceClick(Sender: TObject);
var
        balance : Double;
begin
        {**********************************************************************}
        { ȸ ܿƮ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetBalance
        {**********************************************************************}
        
        try
                balance := accountCheckService.GetBalance(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ܿƮ : ' + FloatToStr(balance));     
        end   

end;

procedure TfrmExample.btnGetUnitCost_ACCClick(Sender: TObject);
var
        unitcost : Single;
        serviceType : String;
begin
        {**********************************************************************}
        { ¼ȸ ݵǴ Ʈ ܰ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetUnitCost
        {**********************************************************************}
        serviceType := '';
        try
                unitcost := accountCheckService.GetUnitCost(txtCorpNum.text, serviceType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ȸܰ : '+ FloatToStr(unitcost));
        end;

end;

procedure TfrmExample.btnGetUnitCost_DEPClick(Sender: TObject);
var
        unitcost : Single;
        serviceType : String;
begin
        {**********************************************************************}
        { ½Ǹȸ ݵǴ Ʈ ܰ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetUnitCost
        {**********************************************************************}
        serviceType := 'Ǹ';
        try
                unitcost := accountCheckService.GetUnitCost(txtCorpNum.text, serviceType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ȸܰ : '+ FloatToStr(unitcost));
        end;

end;

procedure TfrmExample.btnGetAccessURLClick(Sender: TObject);
var
  resultURL : String;
begin
        {**********************************************************************}
        { ˺ Ʈ α ·   ִ  ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#GetAccessURL
        {**********************************************************************}

        try
                resultURL := accountCheckService.getAccessURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL : ' + #13 + resultURL);
        end   

end;

procedure TfrmExample.btnGetChargeURLClick(Sender: TObject);
var
  resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ    ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetChargeURL
        {**********************************************************************}
        
        try
                resultURL := accountCheckService.getChargeURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL : ' + #13 + resultURL);
        end         
end;

procedure TfrmExample.btnGetPartnerPointClick(Sender: TObject);
var
        balance : Double;
begin
        {**********************************************************************}
        { Ʈ ܿƮ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetPartnerBalance
        {**********************************************************************}
        
        try
                balance := accountCheckService.GetPartnerBalance(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ܿƮ : ' + FloatToStr(balance));
        end   
        
end;

procedure TfrmExample.btnRegistContactClick(Sender: TObject);
var
        response : TResponse;
        joinInfo : TJoinContact;
begin
        {**********************************************************************}
        { ȸ ڹȣ (˺ α ) ߰մϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#RegistContact
        {**********************************************************************}

        // [ʼ]  ̵ (6 ̻ 50 ̸)
        joinInfo.id := 'testkorea';

        // йȣ (8 ̻ 20 ̸) ,  ,Ư 
        joinInfo.Password := 'asdf123!@';

        // [ʼ] ڸ(ѱ̳  100 ̳)
        joinInfo.personName := 'ڼ';

        // [ʼ] ó (ִ 20)
        joinInfo.tel := '070-4304-2991';

        // [ʼ] ̸ (ִ 100)
        joinInfo.email := 'test@test.com';

        //  , 1-α / 2-б / 3-ȸ
        joinInfo.searchRole := '3';

        try
                response := accountCheckService.RegistContact(txtCorpNum.text, joinInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end   
        
end;

procedure TfrmExample.btnListContactClick(Sender: TObject);
var
        InfoList : TContactInfoList;
        tmp : string;
        i : Integer;
begin
        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#ListContact
        {**********************************************************************}

        try
                InfoList := accountCheckService.ListContact(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'id(̵) | email(̸) | personName() | searchRole( ) | ';
                tmp := tmp + 'tel(ó) | mgrYN( ) | regDT(Ͻ) | state()' + #13;

                for i := 0 to Length(InfoList) -1 do
                begin
                        tmp := tmp + InfoList[i].id + ' | ';
                        tmp := tmp + InfoList[i].email + ' | ';
                        tmp := tmp + InfoList[i].personName + ' | ';
                        tmp := tmp + InfoList[i].searchRole + ' | ';
                        tmp := tmp + InfoList[i].tel + ' | ';
                        tmp := tmp + BoolToStr(InfoList[i].mgrYN) + ' | ';
                        tmp := tmp + InfoList[i].regDT + ' | ';
                        tmp := tmp + IntToStr(InfoList[i].state) + #13;
                end;
                ShowMessage(tmp);
        end     
end;

procedure TfrmExample.btnUpdateContactClick(Sender: TObject);
var
        contactInfo : TContactInfo;
        response : TResponse;
begin

        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  մϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#UpdateContact
        {**********************************************************************}

        contactInfo := TContactInfo.Create;

        //  ̵
        contactInfo.id := 'testkorea';

        // ڸ (ִ 100)
        contactInfo.personName := '׽Ʈ ';

        // ó (ִ 20)
        contactInfo.tel := '070-4304-2991';

        // ̸ ּ (ִ 100)
        contactInfo.email := 'test@test.com';

        //  , 1-α / 2-б / 3-ȸ
        contactInfo.searchRole := '3';


        try
                response := accountCheckService.UpdateContact(txtCorpNum.text, contactInfo, txtUserID.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end    
end;

procedure TfrmExample.btnGetCorpInfoClick(Sender: TObject);
var
        corpInfo : TCorpInfo;
        tmp : string;
begin
        {**********************************************************************}
        { ȸ ȸ Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#GetCorpInfo
        {**********************************************************************}

        try
                corpInfo := accountCheckService.GetCorpInfo(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'CorpName (ȣ) : ' + corpInfo.CorpName + #13;
                tmp := tmp + 'CeoName (ǥڼ) : ' + corpInfo.CeoName + #13;
                tmp := tmp + 'BizType () : ' + corpInfo.BizType + #13;
                tmp := tmp + 'BizClass () : ' + corpInfo.BizClass + #13;
                tmp := tmp + 'Addr (ּ) : ' + corpInfo.Addr + #13;
                ShowMessage(tmp);
        end    
end;

procedure TfrmExample.btnUpdateCorpInfoClick(Sender: TObject);
var
        corpInfo : TCorpInfo;
        response : TResponse;
begin
        {**********************************************************************}
        { ȸ ȸ մϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#UpdateCorpInfo
        {**********************************************************************}

        corpInfo := TCorpInfo.Create;

        // ǥڸ, ִ 100
        corpInfo.ceoname := 'ǥڸ';

        // ȣ, ִ 200
        corpInfo.corpName := 'ȣ';

        // , ִ 100
        corpInfo.bizType := '';

        // , ִ 100
        corpInfo.bizClass := '';

        // ּ, ִ 300
        corpInfo.addr := 'Ư   517';

        try
                response := accountCheckService.UpdateCorpInfo(txtCorpNum.text, corpInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end      
end;

procedure TfrmExample.btnGetChargeInfo_ACCClick(Sender: TObject);
var
        chargeInfo : TAccountCheckChargeInfo;
        serviceType : String;
        tmp : String;
begin
        {**********************************************************************}
        { ¼ȸ API   Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetChargeInfo
        {**********************************************************************}

        serviceType := '';
        
        try
                chargeInfo := accountCheckService.GetChargeInfo(txtCorpNum.text, serviceType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'unitCost (ܰ) : ' + chargeInfo.unitCost + #13;
                tmp := tmp + 'chargeMethod () : ' + chargeInfo.chargeMethod + #13;
                tmp := tmp + 'rateSystem () : ' + chargeInfo.rateSystem + #13;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnGetChargeInfo_DEPClick(Sender: TObject);
var
        chargeInfo : TAccountCheckChargeInfo;
        serviceType : String;
        tmp : String;
begin
        {**********************************************************************}
        { ½Ǹȸ API   Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetChargeInfo
        {**********************************************************************}

        serviceType := 'Ǹ';
        
        try
                chargeInfo := accountCheckService.GetChargeInfo(txtCorpNum.text, serviceType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'unitCost (ܰ) : ' + chargeInfo.unitCost + #13;
                tmp := tmp + 'chargeMethod () : ' + chargeInfo.chargeMethod + #13;
                tmp := tmp + 'rateSystem () : ' + chargeInfo.rateSystem + #13;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnGetPartnerURL_CHRGClick(Sender: TObject);
var
  resultURL : String;
begin
        {**********************************************************************}
        { Ʈ Ʈ    ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetPartnerURL
        {**********************************************************************}
        
        try
                resultURL := accountCheckService.getPartnerURL(txtCorpNum.Text, 'CHRG');
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end
end;

procedure TfrmExample.btnGetPaymentURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ  Ȯ   ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetPaymentURL
        {**********************************************************************}
        
        try
                resultURL := accountCheckService.getPaymentURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end
end;

procedure TfrmExample.btnGetUseHistoryURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ 볻 Ȯ   ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/point#GetUseHistoryURL
        {**********************************************************************}

        try
                resultURL := accountCheckService.getUseHistoryURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end
end;

procedure TfrmExample.btnGetContactInfoClick(Sender: TObject);
var
        contactInfo : TContactInfo;
        contactID : string;
        tmp : string;
begin
        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  Ȯմϴ.
        { - https://developers.popbill.com/reference/accountcheck/delphi/api/member#GetContactInfo
        {**********************************************************************}

        contactID := 'testkorea';
        
        try
                contactInfo := accountCheckService.getContactInfo(txtCorpNum.Text, contactID);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if accountCheckService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(accountCheckService.LastErrCode) + #10#13 +'޽ : '+ accountCheckService.LastErrMessage);
        end
        else
        begin
                tmp := 'id (̵) : ' + contactInfo.id + #13;
                tmp := tmp + 'personName ( ) : ' + contactInfo.personName + #13;
                tmp := tmp + 'tel ( ó(ȭȣ)) : ' + contactInfo.tel + #13;
                tmp := tmp + 'email ( ̸) : ' + contactInfo.email + #13;
                tmp := tmp + 'regDT ( Ͻ) : ' + contactInfo.regDT + #13;
                tmp := tmp + 'searchRole ( ) : ' + contactInfo.searchRole + #13;
                tmp := tmp + 'mgrYN ( ) : ' + booltostr(contactInfo.mgrYN) + #13;
                tmp := tmp + 'state () : ' + inttostr(contactInfo.state) + #13;
                ShowMessage(tmp);
        end
end;

procedure TfrmExample.cbIdentityNumTypeChange(Sender: TObject);
begin
        IdentityNumType := cbIdentityNumType.Text;
end;

end.