{******************************************************************************}
{ ˺ ѽ API Delphi SDK Example
{
{ -  SDK  ȳ : https://developers.popbill.com/guide/fax/delphi/getting-started/tutorial
{ - Ʈ  : 2022-04-07
{ -   ó : 1600-9854
{ -   ̸ : code@linkhubcorp.com
{
{ <׽Ʈ  غ>
{ (1) 31, 34 ο  ũ̵(LinkID) Ű(SecretKey)
{    ũ Խ Ϸ ߱޹  
{                                                                              
{******************************************************************************}

unit Example;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TypInfo, Popbill, PopbillFax, ExtCtrls, Grids;

const
        {**********************************************************************}
        { - (ũ̵, Ű) Ʈ ȸ ĺϴ        }
        {    ǹǷ  ʵ Ͻñ ٶϴ              }
        { -  ȯĿ   ʽϴ.                  }
        {**********************************************************************}

        // ũ̵.
        LinkID = 'TESTER';

        // Ʈ ſ Ű.  .
        SecretKey = 'SwWxqU+0TErBXy/9TVjIPEnI0VTUMMSQZtJf3Ed8q3I=';

type
  TfrmExample = class(TForm)
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    btnJoinMember: TButton;
    GroupBox11: TGroupBox;
    btnGetUnitCost: TButton;
    GroupBox12: TGroupBox;
    btnGetAccessURL: TButton;
    txtCorpNum: TEdit;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    txtUserID: TEdit;
    GroupBox5: TGroupBox;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    txtReserveDT: TEdit;
    btnSendFax_single: TButton;
    btnSendThousandSame: TButton;
    OpenDialog1: TOpenDialog;
    btnMultiFile: TButton;
    btnMultiFileSingle: TButton;
    btnCheckID: TButton;
    btnCheckIsMember: TButton;
    btnLitContact: TButton;
    btnUpdateContact: TButton;
    GroupBox1: TGroupBox;
    btnRegistContact: TButton;
    btnGetCorpInfo: TButton;
    btnUpdateCorpInfo: TButton;
    btnGetChargeInfo: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    btnGetSenderNumberList: TButton;
    btnGetSenderNumberMgtURL: TButton;
    GroupBox10: TGroupBox;
    GroupBox13: TGroupBox;
    Label1: TLabel;
    txtReceiptNum: TEdit;
    btnGetMessage: TButton;
    btnCancelReserve: TButton;
    btnResendFax: TButton;
    btnResendFaxSame: TButton;
    btnGetSentListURL: TButton;
    btnSearch: TButton;
    GroupBox7: TGroupBox;
    btnGetPartnerBalance: TButton;
    btnGetPartnerURL_CHRG: TButton;
    GroupBox6: TGroupBox;
    btnGetBalance: TButton;
    btnGetChargeURL: TButton;
    Label5: TLabel;
    txtRequestNum: TEdit;
    btnGetMessageRN: TButton;
    btnCancelReserveRN: TButton;
    btnResendFaxRN: TButton;
    btnResendFaxSameRN: TButton;
    btnGetPreviewURL: TButton;
    btnGetPaymentURL: TButton;
    btnGetUseHistoryURL: TButton;
    btnGetContactInfo: TButton;
    Button1: TButton;
    btnGetChargeInfo2: TButton;
    btnGetUnitCost2: TButton;
    txtURL: TEdit;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action:TCloseAction);
    procedure btnGetAccessURLClick(Sender: TObject);
    procedure btnJoinMemberClick(Sender: TObject);
    procedure btnGetBalanceClick(Sender: TObject);
    procedure btnGetUnitCostClick(Sender: TObject);
    procedure btnGetPartnerBalanceClick(Sender: TObject);
    procedure btnSendFax_singleClick(Sender: TObject);
    procedure btnCancelReserveClick(Sender: TObject);
    procedure btnSendThousandSameClick(Sender: TObject);
    procedure btnGetMessageClick(Sender: TObject);
    procedure btnMultiFileClick(Sender: TObject);
    procedure btnMultiFileSingleClick(Sender: TObject);
    procedure btnGetSentListURLClick(Sender: TObject);
    procedure btnCheckIDClick(Sender: TObject);
    procedure btnRegistContactClick(Sender: TObject);
    procedure btnLitContactClick(Sender: TObject);
    procedure btnUpdateContactClick(Sender: TObject);
    procedure btnGetCorpInfoClick(Sender: TObject);
    procedure btnUpdateCorpInfoClick(Sender: TObject);
    procedure btnCheckIsMemberClick(Sender: TObject);
    procedure btnGetChargeURLClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnGetChargeInfoClick(Sender: TObject);
    procedure btnGetChargeInfo2Click(Sender: TObject);
    procedure btnResendFaxClick(Sender: TObject);
    procedure btnResendFaxSameClick(Sender: TObject);
    procedure btnGetSenderNumberListClick(Sender: TObject);
    procedure btnGetSenderNumberMgtURLClick(Sender: TObject);
    procedure btnGetPartnerURL_CHRGClick(Sender: TObject);
    procedure btnGetMessageRNClick(Sender: TObject);
    procedure btnCancelReserveRNClick(Sender: TObject);
    procedure btnResendFaxRNClick(Sender: TObject);
    procedure btnResendFaxSameRNClick(Sender: TObject);
    procedure btnGetPreviewURLClick(Sender: TObject);
    procedure btnGetPaymentURLClick(Sender: TObject);
    procedure btnGetUseHistoryURLClick(Sender: TObject);
    procedure btnGetContactInfoClick(Sender: TObject);
    procedure btnCheckSenderNumberClick(Sender: TObject);
    procedure btnGetUnitCost2Click(Sender: TObject);
  private
    faxService : TFaxService;
  public
    { Public declarations }
  end;

var
  frmExample: TfrmExample;
implementation

{$R *.DFM}

procedure TfrmExample.FormCreate(Sender: TObject);
begin
        faxService := TFaxService.Create(LinkID,SecretKey);
        
        // ȯ , true-߿, false-
        faxService.IsTest := true;

        // Exception ó , true-, false-̻, ⺻(true)
        faxService.IsThrowException := true;

        // ū IPѱ 뿩, true-, false-̻, ⺻(true)
        faxService.IPRestrictOnOff := true;

        //ýý ð 뿩, true-, false-̻, ⺻(true)
        faxService.UseLocalTimeYN := false;
        
        //׸ ʱȭ
        stringgrid1.Cells[0,0] := 'state';
        stringgrid1.Cells[1,0] := 'result';
        stringgrid1.Cells[2,0] := 'sendnum';
        stringgrid1.Cells[3,0] := 'senderName';
        stringgrid1.Cells[4,0] := 'receiveNum';
        stringgrid1.Cells[5,0] := 'receiveNumType';
        stringgrid1.Cells[6,0] := 'receiveName';
        stringgrid1.Cells[7,0] := 'title';
        stringgrid1.Cells[8,0] := 'sendCnt';
        stringgrid1.Cells[9,0] := 'successCnt';
        stringgrid1.Cells[10,0] := 'failCnt';
        stringgrid1.Cells[11,0] := 'refundCnt';
        stringgrid1.Cells[12,0] := 'cancelCnt';
        stringgrid1.Cells[13,0] := 'reserveDT';
        stringgrid1.Cells[14,0] := 'receiptDT';
        stringgrid1.Cells[15,0] := 'sendDT';
        stringgrid1.Cells[16,0] := 'resultDT';
        stringgrid1.Cells[17,0] := 'fileNames';
        stringgrid1.Cells[18,0] := 'receiptNum';
        stringgrid1.Cells[19,0] := 'requestNum';
        stringgrid1.Cells[20,0] := 'chargePageCnt';
        stringgrid1.Cells[21,0] := 'tiffFileSize';
        stringgrid1.Cells[22,0] := 'interOPRefKey';
end;

procedure TfrmExample.FormClose(Sender:TObject; var Action:TCloseAction);
begin
	faxService.free;
	Action := caFree;
end;

function IfThen(condition :bool; trueVal :String ; falseVal : String) : string;
begin
    if condition then result := trueVal else result := falseVal;
end;

function BoolToStr(b:Boolean):String;
begin
    if b = true then BoolToStr:='True';
    if b = false then BoolToStr:='False';
end;

procedure TfrmExample.btnGetAccessURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ˺ Ʈ α ·   ִ  ˾ URL ȯմϴ.           
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#GetAccessURL
        {**********************************************************************}

        try
                resultURL := faxService.getAccessURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;

end;

procedure TfrmExample.btnJoinMemberClick(Sender: TObject);
var
        response : TResponse;
        joinInfo : TJoinForm;
begin

        {**********************************************************************}
        { ڸ ȸ óմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#JoinMember
        {**********************************************************************}

        // ũ̵
        joinInfo.LinkID := LinkID;

        // ڹȣ '-' , 10ڸ
        joinInfo.CorpNum := '4364364364';

        // ǥڼ, ִ 100
        joinInfo.CEOName := 'ǥڼ';

        // ȣ, ִ 200
        joinInfo.CorpName := 'ũ';

        // ּ, ִ 300
        joinInfo.Addr := 'ּ';

        // , ִ 100
        joinInfo.BizType := '';

        // , ִ 100
        joinInfo.BizClass := '';

        // ̵, 6̻ 50 ̸
        joinInfo.ID     := 'userid';

        // йȣ (8 ̻ 20 ̸) ,  ,Ư 
        joinInfo.Password := 'asdf123!@';

        // ڸ, ִ 100
        joinInfo.ContactName := 'ڸ';

        //  ó, ִ 20
        joinInfo.ContactTEL :='070-4304-2991';

        //  , ִ 100
        joinInfo.ContactEmail := 'code@linkhub.co.kr';

        try
                response := faxService.JoinMember(joinInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage(IntToStr(response.code) + ' | ' +  response.Message);
        end;

end;

procedure TfrmExample.btnGetBalanceClick(Sender: TObject);
var
        balance : Double;
begin
        {**********************************************************************}
        { ȸ ܿƮ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetBalance
        {**********************************************************************}
        
        try
                balance := faxService.GetBalance(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ܿƮ : ' + FloatToStr(balance));
        end;
end;

procedure TfrmExample.btnGetUnitCostClick(Sender: TObject);
var
        receiveNumType : String;
        unitcost : Single;
begin
        {**********************************************************************}
        { ѽ Ϲݸ ۽ ݵǴ Ʈ ܰ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetUnitCost
        {**********************************************************************}

        try
                receiveNumType := 'Ϲ';
                unitcost := faxService.GetUnitCost(txtCorpNum.text, receiveNumType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('FAX ۴ܰ : '+ FloatToStr(unitcost));
        end;

end;

procedure TfrmExample.btnGetUnitCost2Click(Sender: TObject);
var
        receiveNumType : String;
        unitcost : Single;
begin
        {**********************************************************************}
        { ѽ ɸ ۽ ݵǴ Ʈ ܰ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetUnitCost
        {**********************************************************************}

        try
                receiveNumType := '';
                unitcost := faxService.GetUnitCost(txtCorpNum.text, receiveNumType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('FAX ۴ܰ : '+ FloatToStr(unitcost));
        end;

end;

procedure TfrmExample.btnGetPartnerBalanceClick(Sender: TObject);
var
        balance : Double;
begin
        {**********************************************************************}
        { Ʈ ܿƮ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetPartnerBalance 
        {**********************************************************************}
        
        try
                balance := faxService.GetPartnerBalance(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ܿƮ : ' + FloatToStr(balance));
        end;

end;

procedure TfrmExample.btnSendFax_singleClick(Sender: TObject);
var
        filePath, receiptNum, senderNum, senderName, receiverNum, receiverName,
        title, requestNum : string;
        adsYN : Boolean;
begin
        {***************************************************************************}
        { ѽ 1 մϴ. (ִ  : 20)
        { - https://developers.popbill.com/reference/fax/delphi/api/send#SendFAX
        {***************************************************************************}

        if OpenDialog1.Execute then begin
              filePath := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        // ߽Źȣ
        senderNum := '07043042992';

        // ߽ڸ
        senderName := '߽ڸ';

        // ѽȣ
        receiverNum := '070111222';

        // ڸ
        receiverName := 'ڸ';

        // ѽ ۿ
        adsYN := False;

        // ѽ
        title := 'ѽ ܰ ';

        // ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        requestNum := txtRequestNum.text;

        try
                receiptNum := faxService.SendFAX(txtCorpNum.Text, senderNum,
                                                 senderName, receiverNum,
                                                 receiverName, filePath,
                                                 txtReserveDT.Text, txtUserID.Text,
                                                 adsYN, title,
                                                 requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;

end;

procedure TfrmExample.btnCancelReserveClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { ˺ ȯ ȣ   ѽ  մϴ. (ð 10  )
        { - https://developers.popbill.com/reference/fax/delphi/api/send#CancelReserve
        {**********************************************************************}

        try
                response := faxService.CancelReserve(txtCorpNum.Text, txtReceiptNum.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;
end;

procedure TfrmExample.btnSendThousandSameClick(Sender: TObject);
var
        receiptNum, filePath, senderNum, senderName, title, requestNum : String;
        adsYN : Boolean;
        receivers : TReceiverList;
        i :Integer;
begin
        {***************************************************************************}
        {  ѽ ټ ڿ ϱ  ˺ մϴ. (ִ   : 20) (ִ 1,000)
        { - https://developers.popbill.com/reference/fax/delphi/api/send#SendFAXSame
        {***************************************************************************}

        if OpenDialog1.Execute then begin
              filePath := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        // ߽Źȣ
        senderNum := '07043042992';

        // ߽ڸ
        senderName := '߽ڸ';

        // ѽ ۿ
        adsYN := False;

        // ѽ
        title := ' ѽ ';

        // ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        requestNum := txtRequestNum.text;

        //  迭, ִ 1000
        SetLength(receivers,5);
        for i :=0 to Length(receivers) -1 do begin
                receivers[i] := TReceiver.create;
                receivers[i].receiveNum := '070111222';                    //Źȣ
                receivers[i].receiveName := IntToStr(i) + '° ';   //ڸ
                receivers[i].interOPRefKey := 'TEST' + IntToStr(i);   //Ʈ Ű 
        end;

        try
                receiptNum := faxService.SendFAX(txtCorpNum.Text, senderNum,
                                                 senderName, receivers,
                                                 filePath, txtReserveDT.Text,
                                                 txtUserID.Text, adsYN,
                                                 title, requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnGetMessageClick(Sender: TObject);
var
        FaxDetails : TFaxDetailList;
        i :integer;
        j : integer;
        fileNameList : String;
begin
        {**********************************************************************}
        { ˺ ȯ  ȣ  ѽ ۻ   Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/info#GetFaxResult
        {**********************************************************************}

        try
                FaxDetails := faxService.getSendDetail(txtCorpNum.Text,
                                        txtReceiptNum.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);                
        end
        else
        begin
        
        stringgrid1.RowCount := Length(FaxDetails) + 1;                                          

        for i:= 0 to Length(FaxDetails) -1 do begin

               // ۻ ڵ
               stringgrid1.Cells[0,i+1]  := IntToStr(FaxDetails[i].state);

               // ۰ ڵ
               stringgrid1.Cells[1,i+1]  := IntToStr(FaxDetails[i].result);

               //߽Źȣ
               stringgrid1.Cells[2,i+1]  := FaxDetails[i].sendNum;

               //߽ڸ
               stringgrid1.Cells[3,i+1]  := FaxDetails[i].senderName;

               //Źȣ
               stringgrid1.Cells[4,i+1]  := FaxDetails[i].receiveNum;

               //Źȣ 
               stringgrid1.Cells[5,i+1]  := FaxDetails[i].receiveNumType;

               //ڸ
               stringgrid1.Cells[6,i+1]  := FaxDetails[i].receiveName;

               //ѽ
               stringgrid1.Cells[7,i+1]  := FaxDetails[i].title;

               //ü 
               stringgrid1.Cells[8,i+1]  := IntToStr(FaxDetails[i].sendPageCnt);

               // 
               stringgrid1.Cells[9,i+1]  := IntToStr(FaxDetails[i].successPageCnt);

               // 
               stringgrid1.Cells[10,i+1]  := IntToStr(FaxDetails[i].failPageCnt);

               //ȯ 
               stringgrid1.Cells[11,i+1] := IntToStr(FaxDetails[i].refundPageCnt);

               // 
               stringgrid1.Cells[12,i+1] := IntToStr(FaxDetails[i].cancelPageCnt);

               //ð
               stringgrid1.Cells[13,i+1] := FaxDetails[i].reserveDT;

               //ð
               stringgrid1.Cells[14,i+1] := FaxDetails[i].receiptDT;

               //߼۽ð
               stringgrid1.Cells[15,i+1] := FaxDetails[i].sendDT;

               //۰ Žð
               stringgrid1.Cells[16,i+1] := FaxDetails[i].resultDT;

               // ϸ Ʈ
               fileNameList := '';

               for j:= 0 to length(FaxDetails[i].fileNames) -1 do begin
                        if j = length(FaxDetails[i].fileNames) -1 then
                                fileNameList := fileNameList +FaxDetails[i].fileNames[j]
                        else
                                fileNameList := fileNameList +FaxDetails[i].fileNames[j] + ', '
               end ;
               stringgrid1.Cells[17,i+1] := fileNameList;

               //ȣ
               stringgrid1.Cells[18,i+1] := FaxDetails[i].receiptNum;

               //ûȣ
               stringgrid1.Cells[19,i+1] := FaxDetails[i].requestNum;

               // 
               stringgrid1.Cells[20,i+1] := IntToStr(FaxDetails[i].chargePageCnt);

               //ȯϿ뷮(:byte)
               stringgrid1.Cells[21,i+1] := FaxDetails[i].tiffFileSize + 'byte';

               //Ʈ  Ű
               stringgrid1.Cells[22,i+1] := FaxDetails[i].interOPRefKey;
        end;

        end;

end;

procedure TfrmExample.btnMultiFileClick(Sender: TObject);
var
        receiptNum, sendNum, senderName, title, requestNum : String;
        adsYN : Boolean;
        filePaths : Array Of string;
        receivers : TReceiverList;
        i :Integer;
begin
        {***************************************************************************}
        {  ѽ ټ ڿ ϱ  ˺ մϴ. (ִ   : 20) (ִ 1,000)
        { - https://developers.popbill.com/reference/fax/delphi/api/send#SendFAXMultiSame
        {***************************************************************************}

        //ѽ ϰ 迭, ִ 20
        setLength(filePaths, 2);

        if OpenDialog1.Execute then begin
              filePaths[0] := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        if OpenDialog1.Execute then begin
              filePaths[1] := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        // ߽Źȣ
        sendNum := '07043042992';

        // ߽ڸ
        senderName := '߽ڸ';

        // ѽ ۿ
        adsYN := False;

        // ѽ
        title := '  ';

        // ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        requestNum := txtRequestNum.text;

        // 迭 ִ 1000
        SetLength(receivers,5);

        for i := 0 to Length(receivers) - 1 do begin
                receivers[i] := TReceiver.create;
                receivers[i].receiveNum := '070111222';                   //ѽȣ
                receivers[i].receiveName := IntToStr(i) + '° ';  //ڸ
        end;

        try
                receiptNum := faxService.SendFAX(txtCorpNum.Text, sendNum,
                                                 senderName, receivers,
                                                 filePaths, txtReserveDT.Text,
                                                 txtUserID.Text, adsYN,
                                                 title, requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnMultiFileSingleClick(Sender: TObject);
var
        receiptNum, senderNum, senderName, receiverNum, receiverName, title,
        requestNum : String;
        filePaths : Array Of string;
        adsYN : Boolean;

        Loop : Integer;
begin
        {***************************************************************************}
        {  ѽ ټ ڿ ϱ  ˺ մϴ. (ִ   : 20) (ִ 1,000)
        { - https://developers.popbill.com/reference/fax/delphi/api/send#SendFAXMulti
        {***************************************************************************}

        // ѽ  迭, ִ 20
        setLength(filePaths, 2);

        if OpenDialog1.Execute then begin
              filePaths[0] := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        if OpenDialog1.Execute then begin
              filePaths[1] := OpenDialog1.FileName;
        end else begin
                Exit;
        end;

        // ߽Źȣ
        senderNum := '07043042992';

        // ߽ڸ
        senderName := '߽ڸ';

        // ѽȣ
        receiverNum := '070111222';

        // ڸ
        receiverName := 'ڸ';

        // ѽ ۿ
        adsYN := False;

        // ѽ
        title := '  ';

        // ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        requestNum := txtRequestNum.text;

        try
                receiptNum := faxService.SendFAX(txtCorpNum.Text, senderNum,
                                                 senderName, receiverNum,
                                                 receiverName, filePaths,
                                                 txtReserveDT.Text, txtUserID.Text,
                                                 adsYN, title,
                                                 requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnGetSentListURLClick(Sender: TObject);
var
  resultURL : String;
begin
        {**********************************************************************}
        { ѽ ۳ Ȯ  ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/info#GetSentListURL
        {**********************************************************************}

        try
                resultURL := faxService.getSentListURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;

end;

procedure TfrmExample.btnCheckIDClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { ϰ ϴ ̵ ߺθ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#CheckID
        {**********************************************************************}
        
        try
                response := faxService.CheckID(txtUserID.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;
end;

procedure TfrmExample.btnRegistContactClick(Sender: TObject);
var
        response : TResponse;
        joinInfo : TJoinContact;
begin
        {**********************************************************************}
        { ȸ ڹȣ (˺ α ) ߰մϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#RegistContact
        {**********************************************************************}

        // [ʼ]  ̵ (6 ̻ 50 ̸)
        joinInfo.id := 'testkorea';

        // йȣ (8 ̻ 20 ̸) ,  ,Ư 
        joinInfo.Password := 'asdf123!@';

        // [ʼ] ڸ(ѱ̳  100 ̳)
        joinInfo.personName := 'ڼ';

        // [ʼ] ó (ִ 20)
        joinInfo.tel := '070-4304-2991';

        // [ʼ] ̸ (ִ 100)
        joinInfo.email := 'test@test.com';

        //  , 1-α / 2-б / 3-ȸ
        joinInfo.searchRole := '3';

        try
                response := faxService.RegistContact(txtCorpNum.text, joinInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;

end;

procedure TfrmExample.btnLitContactClick(Sender: TObject);
var
        InfoList : TContactInfoList;
        tmp : string;
        i : Integer;
begin
        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#ListContact
        {**********************************************************************}

        try
                InfoList := faxService.ListContact(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'id(̵) | email(̸) | personName() | searchRole( ) | ';
                tmp := tmp + 'tel(ó) | mgrYN( ) | regDT(Ͻ) | state()' + #13;

                for i := 0 to Length(InfoList) - 1 do
                begin
                    tmp := tmp + InfoList[i].id + ' | ';
                    tmp := tmp + InfoList[i].email + ' | ';
                    tmp := tmp + InfoList[i].personName + ' | ';
                    tmp := tmp + InfoList[i].searchRole + ' | ';
                    tmp := tmp + InfoList[i].tel + ' | ';
                    tmp := tmp + BoolToStr(InfoList[i].mgrYN) + ' | ';
                    tmp := tmp + InfoList[i].regDT + ' | ';
                    tmp := tmp + IntToStr(InfoList[i].state) + #13;
                end;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnUpdateContactClick(Sender: TObject);
var
        contactInfo : TContactInfo;
        response : TResponse;
begin
        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  մϴ.                                 
        { - https://developers.popbill.com/reference/fax/delphi/api/member#UpdateContact
        {**********************************************************************}

        contactInfo := TContactInfo.Create;

        //  ̵
        contactInfo.id := 'testkorea';

        // ڸ (ִ 100)
        contactInfo.personName := '׽Ʈ ';

        // ó (ִ 20)
        contactInfo.tel := '070-4304-2991';

        // ̸ ּ (ִ 100)
        contactInfo.email := 'test@test.com';

        //  , 1-α / 2-б / 3-ȸ
        contactInfo.searchRole := '3';


        try
                response := faxService.UpdateContact(txtCorpNum.text, contactInfo, txtUserID.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;

end;

procedure TfrmExample.btnGetCorpInfoClick(Sender: TObject);
var
        corpInfo : TCorpInfo;
        tmp : string;
begin
        {**********************************************************************}
        { ȸ ȸ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#GetCorpInfo
        {**********************************************************************}
        
        try
                corpInfo := faxService.GetCorpInfo(txtCorpNum.text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'CorpName (ȣ) : ' + corpInfo.CorpName + #13;
                tmp := tmp + 'CeoName (ǥ ) : ' + corpInfo.CeoName + #13;
                tmp := tmp + 'BizType () : ' + corpInfo.BizType + #13;
                tmp := tmp + 'BizClass () : ' + corpInfo.BizClass + #13;
                tmp := tmp + 'Addr (ּ) : ' + corpInfo.Addr + #13;
                ShowMessage(tmp);
        end;

end;

procedure TfrmExample.btnUpdateCorpInfoClick(Sender: TObject);
var
        corpInfo : TCorpInfo;
        response : TResponse;
begin
        {**********************************************************************}
        { ȸ ȸ մϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#UpdateCorpInfo
        {**********************************************************************}

        corpInfo := TCorpInfo.Create;

        // ǥڸ, ִ 100
        corpInfo.ceoname := 'ǥڸ';

        // ȣ, ִ 200
        corpInfo.corpName := 'ȣ';

        // , ִ 100
        corpInfo.bizType := '';

        // , ִ 100
        corpInfo.bizClass := '';

        // ּ, ִ 300
        corpInfo.addr := 'Ư   517';

        try
                response := faxService.UpdateCorpInfo(txtCorpNum.text, corpInfo);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;
end;

procedure TfrmExample.btnCheckIsMemberClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { ڹȣ ȸϿ ȸ Կθ Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#CheckIsMember
        {**********************************************************************}

        try
                response := faxService.CheckIsMember(txtCorpNum.text, LinkID);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;

end;

procedure TfrmExample.btnGetChargeURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ    ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetChargeURL
        {**********************************************************************}
        
        try
                resultURL := faxService.getChargeURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
               ShowMessage('URL :  ' + #13 + resultURL);
        end;

end;

procedure TfrmExample.btnSearchClick(Sender: TObject);
var
        SDate, EDate, tmp, Order, fileNameList, QString : String;
        Page, PerPage : Integer;
        State : Array Of String;
        ReserveYN, SenderYN : boolean;
        SearchList : TFaxSearchList;
        i : integer;
        j : integer;
begin
        {**********************************************************************}
        { ˻ǿ شϴ ѽ ۳  ȸմϴ. (ȸⰣ  : ִ 2)
        { - ѽ Ͻ÷κ 2 ̳ Ǹ ȸ  ֽϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/info#Search
        {**********************************************************************}

        // [ʼ] ˻Ⱓ , ۼ(yyyyMMdd)
        SDate := '20220701';

        // [ʼ] ˻Ⱓ , ۼ(yyyyMMdd)
        EDate := '20220730';

        // ѽ ° 迭, 1:, 2:, 3:, 4:
        SetLength(State, 4);
        State[0] := '1';
        State[1] := '2';
        State[2] := '3';
        State[3] := '4';

        //  ˻, true- ȸ, fasle- ȸ
        ReserveYN := false;

        // ȸ, true-ȸ, false-üȸ
        SenderYN := true;

        //  ȣ, ⺻ 1
        Page := 1;

        //  ˻, ⺻ 500
        PerPage := 100;

        // Ĺ, D-, A-
        Order := 'D';

        // ȸ ˻, ߽ڸ Ǵ ڸ 
        QString := '';

        try
                SearchList := faxService.search(txtCorpNum.text, SDate, EDate, State,
                                        ReserveYN, SenderYN, Page, PerPage, Order, QString);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'code (ڵ) : '+IntToStr(SearchList.code) + #13;
                tmp := tmp + 'total ( ˻ Ǽ) : '+ IntToStr(SearchList.total) + #13;
                tmp := tmp + 'perPage ( ˻) : '+ IntToStr(SearchList.perPage) + #13;
                tmp := tmp + 'pageNum ( ȣ) : '+ IntToStr(SearchList.pageNum) + #13;
                tmp := tmp + 'pageCount ( ) : '+ IntToStr(SearchList.pageCount) + #13;
                tmp := tmp + 'message (޽) : '+ SearchList.message + #13#13;
                ShowMessage(tmp);

                stringgrid1.RowCount := Length(SearchList.list) + 1;

                for i:= 0 to Length(SearchList.list) - 1 do begin
                       stringgrid1.Cells[0,i+1] := IntToStr(SearchList.list[i].state);          // ۻ ڵ
                       stringgrid1.Cells[1,i+1] := IntToStr(SearchList.list[i].result);         // ۰ ڵ
                       stringgrid1.Cells[2,i+1] := SearchList.list[i].sendNum;                  // ߽Źȣ
                       stringgrid1.Cells[3,i+1] := SearchList.list[i].senderName;               // ߽ڸ
                       stringgrid1.Cells[4,i+1] := SearchList.list[i].receiveNum;               // Źȣ
                       stringgrid1.Cells[5,i+1] := SearchList.list[i].receiveNumType;           // Źȣ 
                       stringgrid1.Cells[6,i+1] := SearchList.list[i].receiveName;              // ڸ
                       stringgrid1.Cells[7,i+1] := SearchList.list[i].title;                    // ѽ
                       stringgrid1.Cells[8,i+1] := IntToStr(SearchList.list[i].sendPageCnt);    // ü 
                       stringgrid1.Cells[9,i+1] := IntToStr(SearchList.list[i].successPageCnt); //  
                       stringgrid1.Cells[10,i+1] := IntToStr(SearchList.list[i].failPageCnt);    //  
                       stringgrid1.Cells[11,i+1] := IntToStr(SearchList.list[i].refundPageCnt); // ȯ 
                       stringgrid1.Cells[12,i+1] := IntToStr(SearchList.list[i].cancelPageCnt); //  
                       stringgrid1.Cells[13,i+1] := SearchList.list[i].reserveDT;               // ð
                       stringgrid1.Cells[14,i+1] := SearchList.list[i].receiptDT;               // û
                       stringgrid1.Cells[15,i+1] := SearchList.list[i].sendDT;                  // ߼۽ð
                       stringgrid1.Cells[16,i+1] := SearchList.list[i].resultDT;                // ۰ Žð
                       fileNameList := '';

                       for j:= 0 to length(SearchList.list[i].fileNames) -1 do begin            //  ϸ Ʈ
                                if j = length(SearchList.list[i].fileNames) -1 then
                                        fileNameList := fileNameList +SearchList.list[i].fileNames[j]
                                else
                                        fileNameList := fileNameList +SearchList.list[i].fileNames[j] + ', '
                       end ;
                       stringgrid1.Cells[17,i+1] := fileNameList;
                       stringgrid1.Cells[18,i+1] := SearchList.list[i].receiptNum;              // ȣ
                       stringgrid1.Cells[19,i+1] := SearchList.list[i].requestNum;              // ûȣ
                       stringgrid1.Cells[20,i+1] := IntToStr(SearchList.list[i].chargePageCnt); //  
                       stringgrid1.Cells[21,i+1] := SearchList.list[i].tiffFileSize + 'byte';   // ȯϿ뷮 (: byte)
                       stringgrid1.Cells[22,i+1] := SearchList.list[i].interOPRefKey;                //Ʈ  Ű
                end;
                SearchList.Free;
        end;
end;

procedure TfrmExample.btnGetChargeInfoClick(Sender: TObject);
var
        chargeInfo : TFaxChargeInfo;
        receiveNumType : String;
        tmp : String;
begin
        {**********************************************************************}
        { ˺ ѽ API  Ϲݸ  Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetChargeInfo
        {**********************************************************************}

        try
                receiveNumType := 'Ϲ';
                chargeInfo := faxService.GetChargeInfo(txtCorpNum.text, receiveNumType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'unitCost (ܰ) : ' + chargeInfo.unitCost + #13;
                tmp := tmp + 'chargeMethod () : ' + chargeInfo.chargeMethod + #13;
                tmp := tmp + 'rateSystem () : ' + chargeInfo.rateSystem + #13;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnGetChargeInfo2Click(Sender: TObject);
var
        chargeInfo : TFaxChargeInfo;
        receiveNumType : String;
        tmp : String;
begin
        {**********************************************************************}
        { ˺ ѽ API  ɸ  Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetChargeInfo
        {**********************************************************************}

        try
                receiveNumType := '';
                chargeInfo := faxService.GetChargeInfo(txtCorpNum.text, receiveNumType);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'unitCost (ܰ) : ' + chargeInfo.unitCost + #13;
                tmp := tmp + 'chargeMethod () : ' + chargeInfo.chargeMethod + #13;
                tmp := tmp + 'rateSystem () : ' + chargeInfo.rateSystem + #13;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnResendFaxClick(Sender: TObject);
var
        receiptNum, senderNum, senderName, receiverNum, receiverName, title,
        requestNum : String;
begin
        {***************************************************************************}
        { ˺ ȯ ȣ  ѽ 1 մϴ.
        { - ߽/  Է½    ѽ ۵ǰ,   ִ 60  ʴ Ǹ  մϴ.
        { - ѽ  û Ʈ ˴ϴ. (۽н ȯó)
        { - ȯ  ۽ ѽ   Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/send#ResendFAX
        {***************************************************************************}

        //߽Źȣ, ó ߼ 
        senderNum := '';

        //߽ڸ, ó ߼ 
        senderName := '';

        // ѽȣ, ó ߼ 
        receiverNum := '';

        // ڸ, ó ߼ 
        receiverName := '';

        // ѽ
        title := 'ѽ  ';

        //  ѽ ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        //  ѽ ۻȮ(GetSendDetailRN) / (CancelReserveRN)  ̿˴ϴ.
        requestNum := '';

        try
                receiptNum := faxService.ResendFAX(txtCorpNum.Text, txtReceiptNum.Text,
                                                   senderNum, senderName,
                                                   receiverNum, receiverName,
                                                   txtReserveDT.Text, txtUserID.text,
                                                   title, requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnResendFaxSameClick(Sender: TObject);
var
        receiptNum, senderNum, senderName, title, requestNum : String;
        receivers : TReceiverList;
        i : Integer;
begin
        {***************************************************************************}
        {  ѽ ټ ڿ ϱ  ˺ մϴ. (ִ  : 20) (ִ 1,000)
        { - ߽/  Է½    ѽ ۵ǰ,   ִ 60  ʴ Ǹ  մϴ.
        { - ѽ  û Ʈ ˴ϴ. (۽н ȯó)
        { - ȯ  ۽ ѽ   Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/send#ResendFAXSame
        {***************************************************************************}

        // ߽Źȣ, ó ߼ 
        senderNum := '';

        // ߽ڸ, ó ߼ 
        senderName := '';

        // ѽ
        title := 'ѽ   ';

        //  ѽ ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        requestNum := '';

        //    ѽ  ϰ ϴ 
        // Ʒ ڵ  receviers 迭 ̸ 0 Ͽ Լ ȣ
        //SetLength(receivers, 0);

        //    ٸ  迭 
        // 迭 ִ 1000
        SetLength(receivers,10);

        for i := 0 to Length(receivers) - 1 do begin
                receivers[i] := TReceiver.create;
                receivers[i].receiveNum := '01000011'+IntToStr(i);       //ѽȣ
                receivers[i].receiveName := IntToStr(i)+ ' ° '; //ڸ
                receivers[i].interOPRefKey := 'ResendTEST' + IntToStr(i); //Ʈ  Ű 
        end;

        try
                receiptNum := faxService.ResendFAX(txtCorpNum.Text, txtReceiptNum.Text,
                                                   senderNum, senderName, receivers, txtReserveDT.
                                                   Text, txtUserID.Text, title, requestNum);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnGetSenderNumberListClick(Sender: TObject);
var
        SenderNumberList : TFAXSenderNumberList;
        tmp : String;
        i : Integer;
begin
        {**********************************************************************}
        { ˺  ȸ ѽ ߽Źȣ  Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/sendnum#GetSenderNumberList
        {**********************************************************************}

        try
             SenderNumberList := faxService.getSenderNumberList(txtCorpNum.Text);

        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                for i := 0 to Length(SenderNumberList) -1 do
                begin
                        tmp := tmp + '******** ѽ ߽Źȣ  ['+ IntToStr(i+1) + '] ********' + #13;
                        tmp := tmp + 'number(߽Źȣ) : ' + SenderNumberList[i].number + #13;
                        tmp := tmp + 'state(ϻ) : ' + IntToStr(SenderNumberList[i].state) + #13;
                        tmp := tmp + 'representYN(ǥȣ ) : ' + BoolToStr(SenderNumberList[i].representYN) + #13 + #13;
                end;
                ShowMessage(tmp);
        end;
end;

procedure TfrmExample.btnCheckSenderNumberClick(Sender: TObject);
var
        response : TResponse;
        senderNumber : String;
begin
        {**********************************************************************}
        { ѽ ߽Źȣ Ͽθ Ȯմϴ.
        { - ߽Źȣ ° '' 쿡 ϰ 'TResponse'  'code' 1 ȯ˴ϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/sendnum#CheckSenderNumber
        {**********************************************************************}

        //Ȯ ߽Źȣ
        senderNumber := '070-4304-2981';

        try
                response := faxService.CheckSenderNumber(txtCorpNum.Text, senderNumber);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + ' : '+ response.Message);
        end;

end;

procedure TfrmExample.btnGetSenderNumberMgtURLClick(Sender: TObject);
var
  resultURL : String;
begin
        {**********************************************************************}
        { ߽Źȣ ϰ  Ȯϴ ѽ ߽Źȣ   ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/sendnum#GetSenderNumberMgtURL
        {**********************************************************************}

        try
                resultURL := faxService.getSenderNumberMgtURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;        
end;

procedure TfrmExample.btnGetPartnerURL_CHRGClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { Ʈ Ʈ    ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetPartnerURL
        {**********************************************************************}
        
        try
                resultURL := faxService.getPartnerURl(txtCorpNum.Text, 'CHRG');
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;
end;

procedure TfrmExample.btnGetMessageRNClick(Sender: TObject);
var
        FaxDetails : TFaxDetailList;
        i :integer;
        j : integer;
        fileNameList : String;
begin
        {**********************************************************************}
        { Ʈʰ Ҵ ۿû ȣ  ѽ ۻ   Ȯմϴ.          
        { - https://developers.popbill.com/reference/fax/delphi/api/info#GetFaxResultRN
        {**********************************************************************}

        try
                FaxDetails := faxService.getSendDetailRN(txtCorpNum.Text,
                                                         txtRequestNum.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
        
        stringgrid1.RowCount := Length(FaxDetails) + 1;

        for i:= 0 to Length(FaxDetails) -1 do begin

               // ۻ ڵ
               stringgrid1.Cells[0,i+1]  := IntToStr(FaxDetails[i].state);

               // ۰ ڵ
               stringgrid1.Cells[1,i+1]  := IntToStr(FaxDetails[i].result);

               //߽Źȣ
               stringgrid1.Cells[2,i+1]  := FaxDetails[i].sendNum;

               //߽ڸ
               stringgrid1.Cells[3,i+1]  := FaxDetails[i].senderName;

               //Źȣ
               stringgrid1.Cells[4,i+1]  := FaxDetails[i].receiveNum;

               //Źȣ 
               stringgrid1.Cells[5,i+1]  := FaxDetails[i].receiveNumType;

               //ڸ
               stringgrid1.Cells[6,i+1]  := FaxDetails[i].receiveName;

               //ѽ
               stringgrid1.Cells[7,i+1]  := FaxDetails[i].title;

               //ü 
               stringgrid1.Cells[8,i+1]  := IntToStr(FaxDetails[i].sendPageCnt);

               // 
               stringgrid1.Cells[9,i+1]  := IntToStr(FaxDetails[i].successPageCnt);

               // 
               stringgrid1.Cells[10,i+1]  := IntToStr(FaxDetails[i].failPageCnt);

               //ȯ 
               stringgrid1.Cells[11,i+1] := IntToStr(FaxDetails[i].refundPageCnt);

               // 
               stringgrid1.Cells[12,i+1] := IntToStr(FaxDetails[i].cancelPageCnt);

               //ð
               stringgrid1.Cells[13,i+1] := FaxDetails[i].reserveDT;

               //ð
               stringgrid1.Cells[14,i+1] := FaxDetails[i].receiptDT;

               //߼۽ð
               stringgrid1.Cells[15,i+1] := FaxDetails[i].sendDT;

               //۰ Žð
               stringgrid1.Cells[16,i+1] := FaxDetails[i].resultDT;

               // ϸ Ʈ
               fileNameList := '';

               for j:= 0 to length(FaxDetails[i].fileNames) -1 do begin
                        if j = length(FaxDetails[i].fileNames) -1 then
                                fileNameList := fileNameList +FaxDetails[i].fileNames[j]
                        else
                                fileNameList := fileNameList +FaxDetails[i].fileNames[j] + ', '
               end ;
               stringgrid1.Cells[17,i+1] := fileNameList;

               //ȣ
               stringgrid1.Cells[18,i+1] := FaxDetails[i].receiptNum;

               //ûȣ
               stringgrid1.Cells[19,i+1] := FaxDetails[i].requestNum;

               // 
               stringgrid1.Cells[20,i+1] := IntToStr(FaxDetails[i].chargePageCnt);

               //ȯϿ뷮(:byte)
               stringgrid1.Cells[21,i+1] := FaxDetails[i].tiffFileSize + 'byte';

               //Ʈ  Ű
               stringgrid1.Cells[22,i+1] := FaxDetails[i].interOPRefKey;
        end;
        end;
end;

procedure TfrmExample.btnCancelReserveRNClick(Sender: TObject);
var
        response : TResponse;
begin
        {**********************************************************************}
        { Ʈʰ Ҵ ۿû ȣ   ѽ  մϴ. (ð 10  )
        { - https://developers.popbill.com/reference/fax/delphi/api/send#CancelReserveRN
        {**********************************************************************}

        try
                response := faxService.CancelReserveRN(txtCorpNum.Text, txtRequestNum.Text);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('ڵ : ' + IntToStr(response.code) + #10#13 + '޽ : '+ response.Message);
        end;

end;

procedure TfrmExample.btnResendFaxRNClick(Sender: TObject);
var
        receiptNum, senderNum, senderName, receiverNum, receiverName, title,
        originalFAXrequestNum, requestNum : String;
begin
        {**********************************************************************}
        { Ʈʰ Ҵ ۿû ȣ  ѽ 1 մϴ.
        { - ߽/  Է½    ѽ ۵ǰ,   ִ 60  ʴ Ǹ  մϴ.
        { - ѽ  û Ʈ ˴ϴ. (۽н ȯó)
        { - ȯ  ۽ ѽ   Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/send#ResendFAXRN
        {**********************************************************************}

        //߽Źȣ, ó ߼ 
        senderNum := '';

        //߽ڸ, ó ߼ 
        senderName := '';

        // ѽȣ, ó ߼ 
        receiverNum := '';

        // ڸ, ó ߼ 
        receiverName := '';

        // ѽ
        title := 'ѽ  ';

        //  ѽ ۽ Ҵ ۿûȣ (requestNum)
        originalFAXrequestNum := '';

        //  ѽ ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ
        requestNum := txtRequestNum.Text;

        try
                receiptNum := faxService.ResendFAXRN(txtCorpNum.Text, requestNum,
                        senderNum, senderName, receiverNum, receiverName, txtReserveDT.Text,
                        originalFAXrequestNum, txtUserID.text, title);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnResendFaxSameRNClick(Sender: TObject);
var
        receiptNum, senderNum, senderName, title, originalFAXrequestNum, requestNum : String;
        receivers : TReceiverList;
        i : Integer;
begin
        {**********************************************************************}
        { Ʈʰ Ҵ ۿû ȣ  ټ ѽ մϴ. (ִ  : 20) (ִ 1,000)
        { - ߽/  Է½    ѽ ۵ǰ,   ִ 60  ʴ Ǹ  մϴ.
        { - ѽ  û Ʈ ˴ϴ. (۽н ȯó)
        { - ȯ  ۽ ѽ   Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/send#ResendFAXRNSame
        {**********************************************************************}

        // ߽Źȣ, ó ߼ 
        senderNum := '';

        // ߽ڸ, ó ߼ 
        senderName := '';

        // ѽ
        title := 'ѽ   ';

        //  ѽ ۽ Ҵ ۿûȣ (requestNum)
        originalFAXrequestNum := '';

        //  ѽ ۿûȣ
        // Ʈʰ  ǿ  ȣ Ͽ ϴ  .
        // 1~36ڸ . , , (-), (_) Ͽ ˺ ȸ ߺ ʵ Ҵ.
        //  ѽ ۻȮ(GetSendDetailRN) / (CancelReserveRN)  ̿˴ϴ.
        requestNum := txtRequestNum.text;

        //    ѽ  ϰ ϴ 
        // Ʒ ڵ  receviers 迭 ̸ 0 Ͽ Լ ȣ
        //SetLength(receivers, 0);

        //    ٸ  迭 
        // 迭 ִ 1000
        SetLength(receivers,10);

        for i := 0 to Length(receivers) - 1 do begin
                receivers[i] := TReceiver.create;
                receivers[i].receiveNum := '01000011'+IntToStr(i);       //ѽȣ
                receivers[i].receiveName := IntToStr(i)+ ' ° '; //ڸ
        end;

        try
                receiptNum := faxService.ResendFAXRN(txtCorpNum.Text, requestNum,
                        senderNum, senderName, receivers, txtReserveDT.Text,
                        originalFAXrequestNum, txtUserID.Text, title);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;

        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                txtReceiptNum.Text := receiptNum;
                ShowMessage('ȣ(receiptNum) :' + receiptNum);
        end;
end;

procedure TfrmExample.btnGetPreviewURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ѽ ̸ ˾ URL ȯϸ, ѽ  TIF  ȯ Ϸ  ȣ   ֽϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/info#GetPreviewURL
        {**********************************************************************}

        try
                resultURL := faxService.getPreviewURL(txtCorpNum.Text, txtReceiptNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;


        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;

end;

procedure TfrmExample.btnGetPaymentURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ  Ȯ   ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetPaymentURL
        {**********************************************************************}
        
        try
                resultURL := faxService.getPaymentURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                ShowMessage('URL :  ' + #13 + resultURL);
        end;
end;

procedure TfrmExample.btnGetUseHistoryURLClick(Sender: TObject);
var
        resultURL : String;
begin
        {**********************************************************************}
        { ȸ Ʈ 볻 Ȯ   ˾ URL ȯմϴ.
        { - ȯǴ URL  å 30  ȿϸ, ð ʰ Ŀ ش URL    Ұմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/point#GetUseHistoryURL
        {**********************************************************************}

        try
                resultURL := faxService.getUseHistoryURL(txtCorpNum.Text, txtUserID.Text);
                txtURL.Text := resultURL;
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                 ShowMessage('URL :  ' + #13 + resultURL);
        end;
end;

procedure TfrmExample.btnGetContactInfoClick(Sender: TObject);
var
        contactInfo : TContactInfo;
        contactID : string;
        tmp : string;
begin
        {**********************************************************************}
        { ȸ ڹȣ ϵ (˺ α )  Ȯմϴ.
        { - https://developers.popbill.com/reference/fax/delphi/api/member#GetContactInfo
        {**********************************************************************}

        contactID := 'testkorea';
        
        try
                contactInfo := faxService.getContactInfo(txtCorpNum.Text, contactID);
        except
                on le : EPopbillException do begin
                        ShowMessage('ڵ : ' + IntToStr(le.code) + #10#13 +'޽ : '+ le.Message);
                        Exit;
                end;
        end;
        if faxService.LastErrCode <> 0 then
        begin
                ShowMessage('ڵ : ' + IntToStr(faxService.LastErrCode) + #10#13 +'޽ : '+ faxService.LastErrMessage);
        end
        else
        begin
                tmp := 'id (̵) : ' + contactInfo.id + #13;
                tmp := tmp + 'personName ( ) : ' + contactInfo.personName + #13;
                tmp := tmp + 'tel ( ó(ȭȣ)) : ' + contactInfo.tel + #13;
                tmp := tmp + 'email ( ̸) : ' + contactInfo.email + #13;
                tmp := tmp + 'regDT ( Ͻ) : ' + contactInfo.regDT + #13;
                tmp := tmp + 'searchRole ( ) : ' + contactInfo.searchRole + #13;
                tmp := tmp + 'mgrYN ( ) : ' + booltostr(contactInfo.mgrYN) + #13;
                tmp := tmp + 'state () : ' + inttostr(contactInfo.state) + #13;
                ShowMessage(tmp);
        end
end;


end.
